diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
index 34f86546fc9..ea50fcaf5dd 100644
--- a/src/backend/executor/nodeModifyTable.c
+++ b/src/backend/executor/nodeModifyTable.c
@@ -54,10 +54,13 @@
 #include "postgres.h"
 
 #include "access/htup_details.h"
+#include "access/attnum.h"
+#include "access/sysattr.h"
 #include "access/tableam.h"
 #include "access/tupconvert.h"
 #include "access/tupdesc.h"
 #include "access/xact.h"
+#include "catalog/index.h"
 #include "commands/trigger.h"
 #include "executor/execPartition.h"
 #include "executor/executor.h"
@@ -75,6 +78,7 @@
 #include "utils/float.h"
 #include "utils/lsyscache.h"
 #include "utils/rel.h"
+#include "utils/relcache.h"
 #include "utils/snapmgr.h"
 
 
@@ -245,6 +249,10 @@ tts_attr_equal(Oid typid, Oid collation, bool typbyval, int16 typlen,
 	typentry = lookup_type_cache(typid,
 								 TYPECACHE_EQ_OPR | TYPECACHE_EQ_OPR_FINFO);
 
+	/* Use the type's collation if none provided */
+	if (collation == -1)
+		collation = typentry->typcollation;
+
 	/*
 	 * If no equality operator is available, fall back to binary comparison.
 	 * This handles types that don't have proper equality operators defined.
@@ -291,108 +299,415 @@ tts_attr_equal(Oid typid, Oid collation, bool typbyval, int16 typlen,
 }
 
 /*
- * Determine which updated attributes actually changed values between old and
- * new tuples and are referenced by indexes on the relation.
+ * ExecCheckIndexedAttrsForChanges
+ *
+ * Determine which indexes need updating by finding the set of modified
+ * indexed attributes.
+ *
+ * For expression indexes and indexes which implement the amcomparedatums()
+ * index AM API we'll need to form index datum and compare each attribute to
+ * see if any actually changed.
+ *
+ * For expression indexes the result of the expression might not change at all,
+ * this is common with JSONB columns, which require expression indexes.  It is
+ * is commonplace to index one or more fields within a document and perform
+ * updates to the document while leaving the indexed fields unchanged.  These
+ * updates don't necessitate index updates.
+ *
+ * Partial indexes won't trigger index updates when the old/new tuples are both
+ * outside of the predicate range.  A transition into or out of the predicate
+ * does require an index update.
+ *
+ * Indexes that support index-only scans (IOS) should return the value that
+ * is the binary equavalent of what is in the table.  For that reason we must
+ * use datumIsEqual() when deciding if an index update is required or not.
+ *
+ * All other indexes require testing old/new datum for equality, we now test
+ * with a type-specific equality operator and fall back to datumIsEqual()
+ * when that isn't possible.
+ *
+ * For a BTREE index (nbtree) their is an additional reason to use binary
+ * comparison for equality.  TID deduplication on page split in nbtree uses
+ * binary comparison.
+ *
+ * The goal is for the executor to know, ahead of calling into the table AM to
+ * process the update and before calling into the index AM for inserting new
+ * index tuples, which attributes in the new TupleTableSlot, if any, truely
+ * necessitate a new index tuple.
  *
- * Returns a Bitmapset of attribute offsets (0-based, adjusted by
- * FirstLowInvalidHeapAttributeNumber) or NULL if no attributes changed.
+ * Returns a Bitmapset of attributes that intersects with indexes which require
+ * a new index tuple.
  */
 Bitmapset *
 ExecCheckIndexedAttrsForChanges(ResultRelInfo *relinfo,
-								TupleTableSlot *tts_old,
-								TupleTableSlot *tts_new)
+								EState *estate,
+								TupleTableSlot *old_tts,
+								TupleTableSlot *new_tts)
 {
 	Relation	relation = relinfo->ri_RelationDesc;
 	TupleDesc	tupdesc = RelationGetDescr(relation);
-	Bitmapset  *indexed_attrs;
-	Bitmapset  *modified = NULL;
-	int			attidx;
+	Bitmapset  *mix_attrs = NULL;
 
 	/* If no indexes, we're done */
 	if (relinfo->ri_NumIndices == 0)
 		return NULL;
 
 	/*
-	 * Get the set of index key attributes.  This includes summarizing,
-	 * expression indexes and attributes mentioned in the predicate of a
-	 * partition but not those in INCLUDING.
+	 * NOTE: Expression and predicates that are observed to change will have
+	 * all their attributes added into the m_attrs set knowing that some of
+	 * those might not have changed.  Take for instance an index on (a + b)
+	 * followed by an index on (b) with an update that changes only the value
+	 * of 'a'.  We'll add both 'a' and 'b' to the m_attrs set then later when
+	 * reviewing the second index add 'b' to the u_attrs (unchanged) set.  In
+	 * the end, we'll remove all the unchanged from the m_attrs and get our
+	 * desired result.
 	 */
-	indexed_attrs = RelationGetIndexAttrBitmap(relation,
-											   INDEX_ATTR_BITMAP_INDEXED);
-	Assert(!bms_is_empty(indexed_attrs));
 
-	/*
-	 * NOTE: It is important to scan all indexed attributes in the tuples
-	 * because ExecGetAllUpdatedCols won't include columns that may have been
-	 * modified via heap_modify_tuple_by_col which is the case in
-	 * tsvector_update_trigger.
-	 */
-	attidx = -1;
-	while ((attidx = bms_next_member(indexed_attrs, attidx)) >= 0)
+	/* Find the indexes that reference this attribute */
+	for (int i = 0; i < relinfo->ri_NumIndices; i++)
 	{
-		/* attidx is zero-based, attrnum is the normal attribute number */
-		AttrNumber	attrnum = attidx + FirstLowInvalidHeapAttributeNumber;
-		Form_pg_attribute attr;
-		bool		oldnull,
-					newnull;
-		Datum		oldval,
-					newval;
+		Relation	index = relinfo->ri_IndexRelationDescs[i];
+		IndexAmRoutine *amroutine = index->rd_indam;
+		IndexInfo  *indexInfo = relinfo->ri_IndexRelationInfo[i];
+		Bitmapset  *m_attrs = NULL; /* (possibly) modified key attributes */
+		Bitmapset  *p_attrs = NULL; /* (possibly) modified predicate
+									 * attributes */
+		Bitmapset  *u_attrs = NULL; /* unmodified attributes */
+		Bitmapset  *pre_attrs = indexInfo->ii_PredicateAttrs;
+		bool		has_expressions = (indexInfo->ii_Expressions != NIL);
+		bool		has_am_compare = (amroutine->amcomparedatums != NULL);
+		bool		supports_ios = (amroutine->amcanreturn != NULL);
+		bool		is_partial = (indexInfo->ii_Predicate != NIL);
+		TupleTableSlot *save_scantuple;
+		ExprContext *econtext = GetPerTupleExprContext(estate);
+		Datum		old_values[INDEX_MAX_KEYS];
+		bool		old_isnull[INDEX_MAX_KEYS];
+		Datum		new_values[INDEX_MAX_KEYS];
+		bool		new_isnull[INDEX_MAX_KEYS];
+
+		/* If we've reviewed all the attributes on this index, move on */
+		if (bms_is_subset(indexInfo->ii_IndexedAttrs, mix_attrs))
+			continue;
 
-		/*
-		 * If it's a whole-tuple reference, record as modified.  It's not
-		 * really worth supporting this case, since it could only succeed
-		 * after a no-op update, which is hardly a case worth optimizing for.
-		 */
-		if (attrnum == 0)
+		/* Checking partial at this point isn't viable when we're serializable */
+		if (is_partial && IsolationIsSerializable())
 		{
-			modified = bms_add_member(modified, attidx);
-			continue;
+			p_attrs = bms_add_members(p_attrs, pre_attrs);
+		}
+		/* Check partial index predicate */
+		else if (is_partial)
+		{
+			ExprState  *pstate;
+			bool		old_qualifies,
+						new_qualifies;
+
+			if (!indexInfo->ii_CheckedPredicate)
+				pstate = ExecPrepareQual(indexInfo->ii_Predicate, estate);
+			else
+				pstate = indexInfo->ii_PredicateState;
+
+			save_scantuple = econtext->ecxt_scantuple;
+
+			econtext->ecxt_scantuple = old_tts;
+			old_qualifies = ExecQual(pstate, econtext);
+
+			econtext->ecxt_scantuple = new_tts;
+			new_qualifies = ExecQual(pstate, econtext);
+
+			econtext->ecxt_scantuple = save_scantuple;
+
+			indexInfo->ii_CheckedPredicate = true;
+			indexInfo->ii_PredicateState = pstate;
+			indexInfo->ii_PredicateSatisfied = new_qualifies;
+
+			/* Both outside predicate, index doesn't need update */
+			if (!old_qualifies && !new_qualifies)
+				continue;
+
+			/* A transition means we need to update the index */
+			if (old_qualifies != new_qualifies)
+				p_attrs = bms_copy(pre_attrs);
+
+			/*
+			 * When both are within the predicate we must update this index,
+			 * but only if one of the index key attributes changed.
+			 */
 		}
 
 		/*
-		 * Likewise, include in the modified set any system attribute other
-		 * than tableOID; we cannot expect these to be consistent in a HOT
-		 * chain, or even to be set correctly yet in the new tuple.
+		 * Expression indexes, or an index that has a comparison function,
+		 * requires us to form index datums and compare.  We've done all we
+		 * can to avoid this overhead, now it's time to bite the bullet and
+		 * get it done.
+		 *
+		 * XXX: Caching the values/isnull might be a win and avoid one of the
+		 * added calls to FormIndexDatum().
 		 */
-		if (attrnum < 0)
+		if (has_expressions || has_am_compare)
 		{
-			if (attrnum != TableOidAttributeNumber)
-				modified = bms_add_member(modified, attidx);
-			continue;
-		}
+			save_scantuple = econtext->ecxt_scantuple;
 
-		/* Extract values from both slots */
-		oldval = slot_getattr(tts_old, attrnum, &oldnull);
-		newval = slot_getattr(tts_new, attrnum, &newnull);
+			/* Evaluate expressions (if any) to get base datums */
+			econtext->ecxt_scantuple = old_tts;
+			FormIndexDatum(indexInfo, old_tts, estate, old_values, old_isnull);
 
-		/* If one value is NULL and the other is not, they are not equal */
-		if (oldnull != newnull)
-		{
-			modified = bms_add_member(modified, attidx);
-			continue;
+			econtext->ecxt_scantuple = new_tts;
+			FormIndexDatum(indexInfo, new_tts, estate, new_values, new_isnull);
+
+			econtext->ecxt_scantuple = save_scantuple;
+
+			/* Compare the index key datums for equality */
+			for (int j = 0; j < indexInfo->ii_NumIndexKeyAttrs; j++)
+			{
+				AttrNumber	rel_attrnum = indexInfo->ii_IndexAttrNumbers[j];
+				int			rel_attridx = rel_attrnum - FirstLowInvalidHeapAttributeNumber;
+				int			nth_expr = 0;
+				bool		values_equal = false;
+
+				/*
+				 * We can't skip attributes that we've already identified as
+				 * triggering an index update because we may have added an
+				 * attribute from an expression index that didn't change but
+				 * the expression did and that unchanged attribute is
+				 * referenced in a subsequent index where we will discover
+				 * that fact.
+				 */
+
+				/* A change to/from NULL, record this attribute */
+				if (old_isnull[j] != new_isnull[j])
+				{
+					/* Expressions will have rel_attrnum == 0 */
+					if (rel_attrnum == 0)
+						m_attrs = bms_add_members(m_attrs, indexInfo->ii_ExpressionsAttrs);
+					else
+						m_attrs = bms_add_member(m_attrs, rel_attridx);
+					continue;
+				}
+
+				/* Both NULL, no change */
+				if (old_isnull[j])
+				{
+					if (rel_attrnum != 0)
+						u_attrs = bms_add_member(u_attrs, rel_attridx);
+
+					continue;
+				}
+
+				/*
+				 * Use index AM's comparison function if present when
+				 * comparing the index datum formed when creating an index
+				 * key.
+				 */
+				if (has_am_compare)
+				{
+					/*
+					 * NOTE: For AM comparison, pass the 1-based index
+					 * attribute number. The AM's compare function expects the
+					 * same numbering as used internally by the AM.
+					 */
+					values_equal = amroutine->amcomparedatums(index, j + 1,
+															  old_values[j], old_isnull[j],
+															  new_values[j], new_isnull[j]);
+				}
+				else
+				{
+					/* Non-zero attribute means not an expression */
+					if (rel_attrnum != 0)
+					{
+						if (supports_ios)
+						{
+							CompactAttribute *attr = TupleDescCompactAttr(tupdesc, rel_attrnum - 1);
+
+							values_equal = datumIsEqual(old_values[j],
+														new_values[j],
+														attr->attbyval,
+														attr->attlen);
+						}
+						else
+						{
+							Form_pg_attribute attr = TupleDescAttr(tupdesc, rel_attrnum - 1);
+
+							/*
+							 * Compare using type-specific equality which at
+							 * this point is the relation's type because
+							 * FormIndexDatum() will populate the values/nulls
+							 * but won't transform them into the final values
+							 * destined for the index tuple, that's left to
+							 * index_form_tuple() which we don't call (on
+							 * purpose).
+							 */
+							values_equal = tts_attr_equal(attr->atttypid,
+														  attr->attcollation,
+														  attr->attbyval,
+														  attr->attlen,
+														  old_values[j],
+														  new_values[j]);
+						}
+					}
+					else
+					{
+						/*
+						 * An expression on an indexed attribute without
+						 * custom AM comparison function. In this case, becase
+						 * indexes will store the result of the expression's
+						 * evaluation, we can test for equality using the
+						 * expression's result type.  This allows for JSONB
+						 * and custom type equality tests, which may not be
+						 * the same as binary equality, to be in effect.  The
+						 * result stored in the index and used in index-only
+						 * scans will be valid as it is the expressions
+						 * result, which shouldn't change given the same
+						 * input.
+						 *
+						 * At this point the expression's type is what is
+						 * required when testing for equality, not the index's
+						 * type, because the value created by FormIndexDatum()
+						 * is the expression's result.  Later on in
+						 * index_form_tuple() an index may transform the value
+						 * when forming it's key (as is the case with HASH),
+						 * but at this point the Datum is the expression's
+						 * result type.
+						 */
+						Oid			expr_type_oid;
+						int16		typlen;
+						bool		typbyval;
+						Expr	   *expr = (Expr *) list_nth(indexInfo->ii_Expressions, nth_expr);
+
+						Assert(expr != NULL);
+
+						/* Get type OID from the expression */
+						expr_type_oid = exprType((Node *) expr);
+
+						/* Get type information from the OID */
+						get_typlenbyval(expr_type_oid, &typlen, &typbyval);
+
+						values_equal = tts_attr_equal(expr_type_oid,
+													  -1,	/* use TBD expr type */
+													  typbyval,
+													  typlen,
+													  old_values[j],
+													  new_values[j]);
+					}
+				}
+
+				if (!values_equal)
+				{
+					/* Expressions will have rel_attrnum == 0 */
+					if (rel_attrnum == 0)
+						m_attrs = bms_add_members(m_attrs, indexInfo->ii_ExpressionsAttrs);
+					else
+						m_attrs = bms_add_member(m_attrs, rel_attridx);
+				}
+				else
+				{
+					if (rel_attrnum != 0)
+						u_attrs = bms_add_member(u_attrs, rel_attridx);
+				}
+
+				if (rel_attrnum == 0)
+					nth_expr++;
+			}
 		}
+		else
+		{
+			/*
+			 * Here we know that we're reviewing an index that doesn't have a
+			 * partial predicate, doesn't use expressions, and doesn't have a
+			 * amcomparedatums() implementation.  If this index supports IOS
+			 * we need to use binary comparison, if not then type-specific
+			 * will provide a more accurate result.
+			 */
 
-		/* If both are NULL, consider them equal */
-		if (oldnull)
-			continue;
+			/* Compare the index key datums for equality */
+			for (int j = 0; j < indexInfo->ii_NumIndexKeyAttrs; j++)
+			{
+				AttrNumber	rel_attrnum;
+				int			rel_attridx;
+				bool		values_equal = false;
+				bool		old_null,
+							new_null;
+				Datum		old_val,
+							new_val;
 
-		/* Get attribute metadata */
-		Assert(attrnum > 0 && attrnum <= tupdesc->natts);
-		attr = TupleDescAttr(tupdesc, attrnum - 1);
-
-		/* Compare using type-specific equality operator */
-		if (!tts_attr_equal(attr->atttypid,
-							attr->attcollation,
-							attr->attbyval,
-							attr->attlen,
-							oldval,
-							newval))
-			modified = bms_add_member(modified, attidx);
-	}
+				rel_attrnum = indexInfo->ii_IndexAttrNumbers[j];
+				rel_attridx = rel_attrnum - FirstLowInvalidHeapAttributeNumber;
+
+				/* Zero would mean expression, something we don't expect here */
+				Assert(rel_attrnum > 0 && rel_attrnum <= tupdesc->natts);
+
+				/* Extract values from both slots for this attribute */
+				old_val = slot_getattr(old_tts, rel_attrnum, &old_null);
+				new_val = slot_getattr(new_tts, rel_attrnum, &new_null);
 
-	bms_free(indexed_attrs);
+				/*
+				 * If one value is NULL and the other is not, they are not
+				 * equal
+				 */
+				if (old_null != new_null)
+				{
+					m_attrs = bms_add_member(m_attrs, rel_attridx);
+					continue;
+				}
+
+				/* If both are NULL, consider them equal */
+				if (old_null)
+				{
+					u_attrs = bms_add_member(u_attrs, rel_attridx);
+					continue;
+				}
+
+				if (supports_ios)
+				{
+					CompactAttribute *attr = TupleDescCompactAttr(tupdesc, rel_attrnum - 1);
+
+					values_equal = datumIsEqual(old_val,
+												new_val,
+												attr->attbyval,
+												attr->attlen);
+				}
+				else
+				{
+					Form_pg_attribute attr = TupleDescAttr(tupdesc, rel_attrnum - 1);
+
+					/*
+					 * Compare using type-specific equality which at this
+					 * point is the relation's type because FormIndexDatum()
+					 * will populate the values/nulls but won't transform them
+					 * into the final values destined for the index tuple,
+					 * that's left to index_form_tuple() which we don't call
+					 * (on purpose).
+					 */
+					values_equal = tts_attr_equal(attr->atttypid,
+												  attr->attcollation,
+												  attr->attbyval,
+												  attr->attlen,
+												  old_val,
+												  new_val);
+				}
+
+				if (!values_equal)
+					m_attrs = bms_add_member(m_attrs, rel_attridx);
+				else
+					u_attrs = bms_add_member(u_attrs, rel_attridx);
+			}
+		}
+
+		/*
+		 * Here we know all the attributes we thought might be modified and
+		 * all those we know haven't been.  Take the difference and add it to
+		 * the modified indexed attributes set.
+		 */
+		m_attrs = bms_del_members(m_attrs, u_attrs);
+		p_attrs = bms_del_members(p_attrs, u_attrs);
+		mix_attrs = bms_add_members(mix_attrs, m_attrs);
+		mix_attrs = bms_add_members(mix_attrs, p_attrs);
+
+		bms_free(m_attrs);
+		bms_free(u_attrs);
+		bms_free(p_attrs);
+	}
 
-	return modified;
+	return mix_attrs;
 }
 
 /*
@@ -2395,6 +2710,9 @@ ExecUpdateAct(ModifyTableContext *context, ResultRelInfo *resultRelInfo,
 	bool		partition_constraint_failed;
 	TM_Result	result;
 
+	/* The set of modified indexed attributes that trigger new index entries */
+	Bitmapset  *mix_attrs = NULL;
+
 	updateCxt->crossPartUpdate = false;
 
 	/*
@@ -2517,13 +2835,32 @@ lreplace:
 	bms_free(resultRelInfo->ri_ChangedIndexedCols);
 	resultRelInfo->ri_ChangedIndexedCols = NULL;
 
-	resultRelInfo->ri_ChangedIndexedCols =
-		ExecCheckIndexedAttrsForChanges(resultRelInfo, oldSlot, slot);
+	/*
+	 * During updates we'll need a bit more information in IndexInfo but we've
+	 * delayed adding it until here.  We check to ensure that there are
+	 * indexes, that something has changed that is indexed, and that the first
+	 * index doesn't yet have ii_IndexedAttrs set as a way to ensure we only
+	 * build this when needed and only once.  We don't build this in
+	 * ExecOpenIndicies() as it is unnecessary overhead when not performing an
+	 * update.
+	 */
+	if (resultRelInfo->ri_NumIndices > 0 &&
+		bms_is_empty(resultRelInfo->ri_IndexRelationInfo[0]->ii_IndexedAttrs))
+		BuildUpdateIndexInfo(resultRelInfo);
+
+	/*
+	 * Next up we need to find out the set of indexed attributes that have
+	 * changed in value and should trigger a new index tuple.  We could start
+	 * with the set of updated columns via ExecGetUpdatedCols(), but if we do
+	 * we will overlook attributes directly modified by heap_modify_tuple()
+	 * which are not known to ExecGetUpdatedCols().
+	 */
+	mix_attrs = ExecCheckIndexedAttrsForChanges(resultRelInfo, estate, oldSlot, slot);
 
 	/*
-	 * replace the heap tuple
+	 * Call into the table AM to update the heap tuple.
 	 *
-	 * Note: if es_crosscheck_snapshot isn't InvalidSnapshot, we check that
+	 * NOTE: if es_crosscheck_snapshot isn't InvalidSnapshot, we check that
 	 * the row to be updated is visible to that snapshot, and throw a
 	 * can't-serialize error if not. This is a special-case behavior needed
 	 * for referential integrity updates in transaction-snapshot mode
@@ -2535,9 +2872,12 @@ lreplace:
 								estate->es_crosscheck_snapshot,
 								true /* wait for commit */ ,
 								&context->tmfd, &updateCxt->lockmode,
-								resultRelInfo->ri_ChangedIndexedCols,
+								mix_attrs,
 								&updateCxt->updateIndexes);
 
+	Assert(bms_is_empty(resultRelInfo->ri_ChangedIndexedCols));
+	resultRelInfo->ri_ChangedIndexedCols = mix_attrs;
+
 	return result;
 }
 
@@ -2555,7 +2895,7 @@ ExecUpdateEpilogue(ModifyTableContext *context, UpdateContext *updateCxt,
 	ModifyTableState *mtstate = context->mtstate;
 	List	   *recheckIndexes = NIL;
 
-	/* insert index entries for tuple if necessary */
+	/* Insert index entries for tuple if necessary */
 	if (resultRelInfo->ri_NumIndices > 0 && (updateCxt->updateIndexes != TU_None))
 		recheckIndexes = ExecInsertIndexTuples(resultRelInfo,
 											   slot, context->estate,
diff --git a/src/backend/nodes/makefuncs.c b/src/backend/nodes/makefuncs.c
index d69dc090aa4..e9a53b95caf 100644
--- a/src/backend/nodes/makefuncs.c
+++ b/src/backend/nodes/makefuncs.c
@@ -855,10 +855,14 @@ makeIndexInfo(int numattrs, int numkeyattrs, Oid amoid, List *expressions,
 	/* expressions */
 	n->ii_Expressions = expressions;
 	n->ii_ExpressionsState = NIL;
+	n->ii_ExpressionsAttrs = NULL;
 
 	/* predicates  */
 	n->ii_Predicate = predicates;
 	n->ii_PredicateState = NULL;
+	n->ii_PredicateAttrs = NULL;
+	n->ii_CheckedPredicate = false;
+	n->ii_PredicateSatisfied = false;
 
 	/* exclusion constraints */
 	n->ii_ExclusionOps = NULL;
diff --git a/src/include/access/amapi.h b/src/include/access/amapi.h
index 63dd41c1f21..9bdf73eda59 100644
--- a/src/include/access/amapi.h
+++ b/src/include/access/amapi.h
@@ -211,6 +211,33 @@ typedef void (*ammarkpos_function) (IndexScanDesc scan);
 /* restore marked scan position */
 typedef void (*amrestrpos_function) (IndexScanDesc scan);
 
+/*
+ * amcomparedatums - Compare datums to determine if index update is needed
+ *
+ * This function compares old_datum and new_datum to determine if they would
+ * produce different index entries. For extraction-based indexes (GIN, RUM),
+ * this should:
+ *  1. Extract keys from old_datum using the opclass's extractValue function
+ *  2. Extract keys from new_datum using the opclass's extractValue function
+ *  3. Compare the two sets of keys using appropriate equality operators
+ *  4. Return true if the sets are equal (no index update needed)
+ *
+ * The comparison should account for:
+ *  - Different numbers of extracted keys
+ *  - NULL values
+ *  - Type-specific equality (not just binary equality)
+ *  - Opclass parameters (e.g., path in bson_rum_single_path_ops)
+ *
+ * For the DocumentDB example with path='a', this would extract values at
+ * path 'a' from both old and new BSON documents and compare them using
+ * BSON's equality operator.
+ */
+/* identify if updated datums would produce one or more index entries */
+typedef bool (*amcomparedatums_function) (Relation indexRelation,
+										  int attno,
+										  Datum old_datum, bool old_isnull,
+										  Datum new_datum, bool new_isnull);
+
 /*
  * Callback function signatures - for parallel index scans.
  */
@@ -313,6 +340,7 @@ typedef struct IndexAmRoutine
 	amendscan_function amendscan;
 	ammarkpos_function ammarkpos;	/* can be NULL */
 	amrestrpos_function amrestrpos; /* can be NULL */
+	amcomparedatums_function amcomparedatums;	/* can be NULL */
 
 	/* interface functions to support parallel index scans */
 	amestimateparallelscan_function amestimateparallelscan; /* can be NULL */
diff --git a/src/include/access/gin.h b/src/include/access/gin.h
index 13ea91922ef..2f265f4816c 100644
--- a/src/include/access/gin.h
+++ b/src/include/access/gin.h
@@ -100,6 +100,9 @@ extern PGDLLIMPORT int gin_pending_list_limit;
 extern void ginGetStats(Relation index, GinStatsData *stats);
 extern void ginUpdateStats(Relation index, const GinStatsData *stats,
 						   bool is_build);
+extern bool gincomparedatums(Relation index, int attnum,
+							 Datum old_datum, bool old_isnull,
+							 Datum new_datum, bool new_isnull);
 
 extern void _gin_parallel_build_main(dsm_segment *seg, shm_toc *toc);
 
diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index 2f9a2b069cd..5783dbebff0 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -369,7 +369,7 @@ extern TM_Result heap_update(Relation relation, HeapTupleData *oldtup,
 							 TM_FailureData *tmfd, LockTupleMode *lockmode, Buffer buffer,
 							 Page page, BlockNumber block, ItemId lp, Bitmapset *hot_attrs,
 							 Bitmapset *sum_attrs, Bitmapset *pk_attrs, Bitmapset *rid_attrs,
-							 Bitmapset *mix_attrs, Buffer *vmbuffer,
+							 const Bitmapset *mix_attrs, Buffer *vmbuffer,
 							 bool rep_id_key_required, TU_UpdateIndexes *update_indexes);
 extern TM_Result heap_lock_tuple(Relation relation, HeapTuple tuple,
 								 CommandId cid, LockTupleMode mode, LockWaitPolicy wait_policy,
@@ -404,8 +404,8 @@ extern bool heap_tuple_needs_eventual_freeze(HeapTupleHeader tuple);
 
 extern void simple_heap_insert(Relation relation, HeapTuple tup);
 extern void simple_heap_delete(Relation relation, const ItemPointerData *tid);
-extern void simple_heap_update(Relation relation, const ItemPointerData *otid,
-							   HeapTuple tup, TU_UpdateIndexes *update_indexes);
+extern Bitmapset *simple_heap_update(Relation relation, const ItemPointerData *otid,
+									 HeapTuple tup, TU_UpdateIndexes *update_indexes);
 
 extern TransactionId heap_index_delete_tuples(Relation rel,
 											  TM_IndexDeleteOp *delstate);
diff --git a/src/include/access/nbtree.h b/src/include/access/nbtree.h
index 16be5c7a9c1..42bd329eaad 100644
--- a/src/include/access/nbtree.h
+++ b/src/include/access/nbtree.h
@@ -1210,6 +1210,10 @@ extern int	btgettreeheight(Relation rel);
 
 extern CompareType bttranslatestrategy(StrategyNumber strategy, Oid opfamily);
 extern StrategyNumber bttranslatecmptype(CompareType cmptype, Oid opfamily);
+extern bool btcomparedatums(Relation index, int attnum,
+							Datum old_datum, bool old_isnull,
+							Datum new_datum, bool new_isnull);
+
 
 /*
  * prototypes for internal functions in nbtree.c
diff --git a/src/include/access/tableam.h b/src/include/access/tableam.h
index 8a5931a3118..2b9206ff24a 100644
--- a/src/include/access/tableam.h
+++ b/src/include/access/tableam.h
@@ -549,7 +549,7 @@ typedef struct TableAmRoutine
 								 bool wait,
 								 TM_FailureData *tmfd,
 								 LockTupleMode *lockmode,
-								 Bitmapset *updated_cols,
+								 const Bitmapset *updated_cols,
 								 TU_UpdateIndexes *update_indexes);
 
 	/* see table_tuple_lock() for reference about parameters */
@@ -1503,12 +1503,12 @@ static inline TM_Result
 table_tuple_update(Relation rel, ItemPointer otid, TupleTableSlot *slot,
 				   CommandId cid, Snapshot snapshot, Snapshot crosscheck,
 				   bool wait, TM_FailureData *tmfd, LockTupleMode *lockmode,
-				   Bitmapset *updated_cols, TU_UpdateIndexes *update_indexes)
+				   const Bitmapset *mix_cols, TU_UpdateIndexes *update_indexes)
 {
 	return rel->rd_tableam->tuple_update(rel, otid, slot,
 										 cid, snapshot, crosscheck,
 										 wait, tmfd, lockmode,
-										 updated_cols, update_indexes);
+										 mix_cols, update_indexes);
 }
 
 /*
@@ -2011,7 +2011,7 @@ extern void simple_table_tuple_delete(Relation rel, ItemPointer tid,
 									  Snapshot snapshot);
 extern void simple_table_tuple_update(Relation rel, ItemPointer otid,
 									  TupleTableSlot *slot, Snapshot snapshot,
-									  Bitmapset *modified_indexe_attrs,
+									  const Bitmapset *mix_attrs,
 									  TU_UpdateIndexes *update_indexes);
 
 
diff --git a/src/include/catalog/index.h b/src/include/catalog/index.h
index dda95e54903..8d364f8b30f 100644
--- a/src/include/catalog/index.h
+++ b/src/include/catalog/index.h
@@ -132,6 +132,7 @@ extern bool CompareIndexInfo(const IndexInfo *info1, const IndexInfo *info2,
 							 const AttrMap *attmap);
 
 extern void BuildSpeculativeIndexInfo(Relation index, IndexInfo *ii);
+extern void BuildUpdateIndexInfo(ResultRelInfo *resultRelInfo);
 
 extern void FormIndexDatum(IndexInfo *indexInfo,
 						   TupleTableSlot *slot,
diff --git a/src/include/executor/executor.h b/src/include/executor/executor.h
index 993dc0e6ced..a19585ba065 100644
--- a/src/include/executor/executor.h
+++ b/src/include/executor/executor.h
@@ -739,6 +739,11 @@ extern Bitmapset *ExecGetAllUpdatedCols(ResultRelInfo *relinfo, EState *estate);
  */
 extern void ExecOpenIndices(ResultRelInfo *resultRelInfo, bool speculative);
 extern void ExecCloseIndices(ResultRelInfo *resultRelInfo);
+extern Bitmapset *ExecWhichIndexesRequireUpdates(ResultRelInfo *relinfo,
+												 Bitmapset *mix_attrs,
+												 EState *estate,
+												 TupleTableSlot *old_tts,
+												 TupleTableSlot *new_tts);
 extern List *ExecInsertIndexTuples(ResultRelInfo *resultRelInfo,
 								   TupleTableSlot *slot, EState *estate,
 								   bool update,
@@ -800,9 +805,10 @@ extern ResultRelInfo *ExecLookupResultRelByOid(ModifyTableState *node,
 											   Oid resultoid,
 											   bool missing_ok,
 											   bool update_cache);
-extern Bitmapset *ExecCheckIndexedAttrsForChanges(ResultRelInfo *resultRelInfo,
-												  TupleTableSlot *tts_old,
-												  TupleTableSlot *tts_new);
+extern Bitmapset *ExecCheckIndexedAttrsForChanges(ResultRelInfo *relinfo,
+												  EState *estate,
+												  TupleTableSlot *old_tts,
+												  TupleTableSlot *new_tts);
 extern bool tts_attr_equal(Oid typid, Oid collation, bool typbyval, int16 typlen,
 						   Datum value1, Datum value2);
 
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 898368fb8cb..d8e88817206 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -174,15 +174,29 @@ typedef struct IndexInfo
 	 */
 	AttrNumber	ii_IndexAttrNumbers[INDEX_MAX_KEYS];
 
+	/*
+	 * All key, expression, sumarizing, and partition attributes referenced by
+	 * this index
+	 */
+	Bitmapset  *ii_IndexedAttrs;
+
 	/* expr trees for expression entries, or NIL if none */
 	List	   *ii_Expressions; /* list of Expr */
 	/* exec state for expressions, or NIL if none */
 	List	   *ii_ExpressionsState;	/* list of ExprState */
+	/* attributes exclusively referenced by expression indexes */
+	Bitmapset  *ii_ExpressionsAttrs;
 
 	/* partial-index predicate, or NIL if none */
 	List	   *ii_Predicate;	/* list of Expr */
 	/* exec state for expressions, or NIL if none */
 	ExprState  *ii_PredicateState;
+	/* attributes referenced by the predicate */
+	Bitmapset  *ii_PredicateAttrs;
+	/* partial index predicate determined yet? */
+	bool		ii_CheckedPredicate;
+	/* amupdate hint used to avoid rechecking predicate */
+	bool		ii_PredicateSatisfied;
 
 	/* Per-column exclusion operators, or NULL if none */
 	Oid		   *ii_ExclusionOps;	/* array with one entry per column */
@@ -494,6 +508,11 @@ typedef struct ResultRelInfo
 	Bitmapset  *ri_extraUpdatedCols;
 	/* true if the above has been computed */
 	bool		ri_extraUpdatedCols_valid;
+
+	/*
+	 * For UPDATE a Bitmapset of the attributes that are both indexed and have
+	 * changed in value.
+	 */
 	Bitmapset  *ri_ChangedIndexedCols;
 
 	/* Projection to generate new tuple in an INSERT/UPDATE */
